Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_output_write_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/phys_output_write_mod.F90	(revision 4727)
@@ -17,7 +17,7 @@
   SUBROUTINE phys_output_write(itap, pdtphys, paprs, pphis, &
        pplay, lmax_th, aerosol_couple,         &
-       ok_ade, ok_aie, ok_volcan, ivap, iliq, isol, ok_sync, &
+       ok_ade, ok_aie, ok_volcan, ivap, iliq, isol, ibs, ok_sync, &
        ptconv, read_climoz, clevSTD, ptconvth, &
-       d_u, d_t, qx, d_qx, zmasse, flag_aerosol, flag_aerosol_strat, ok_cdnc)
+       d_u, d_t, qx, d_qx, zmasse, flag_aerosol, flag_aerosol_strat, ok_cdnc, t, u1, v1)
 
     ! This subroutine does the actual writing of diagnostics that were
@@ -31,4 +31,5 @@
     USE time_phylmdz_mod, ONLY: day_step_phy, start_time, itau_phy
     USE vertical_layers_mod, ONLY : ap, bp, aps, bps
+    USE phystokenc_mod, ONLY: offline
     USE phys_output_ctrlout_mod, ONLY: o_phis, o_aire, is_ter, is_lic, is_oce, &
          o_longitude, o_latitude, &
@@ -47,5 +48,6 @@
          o_psol, o_mass, o_qsurf, o_qsol, &
          o_precip, o_rain_fall, o_rain_con, o_ndayrain, o_plul, o_pluc, o_plun, &
-         o_snow, o_msnow, o_fsnow, o_evap, o_ep,o_epmax_diag, & ! epmax_cape
+         o_snow, o_msnow, o_fsnow, o_evap, o_snowerosion, o_ustart_lic, o_rhosnow_lic, o_bsfall, & 
+         o_ep,o_epmax_diag, & ! epmax_cape
          o_tops, o_tops0, o_topl, o_topl0, &
          o_SWupTOA, o_SWupTOAclr, o_SWupTOAcleanclr, o_SWdnTOA, o_fdiffSWdnSFC, &
@@ -81,5 +83,5 @@
          o_Mipsh, o_Ma, &
          o_dnwd, o_dnwd0, o_ftime_deepcv, o_ftime_con, o_mc, &
-         o_prw, o_prlw, o_prsw, o_s_pblh, o_s_pblt, o_s_lcl, &
+         o_prw, o_prlw, o_prsw, o_prbsw, o_s_pblh, o_s_pblt, o_s_lcl, &
          o_s_therm, o_uSTDlevs, o_vSTDlevs, &
          o_wSTDlevs, o_zSTDlevs, o_qSTDlevs, &
@@ -106,5 +108,5 @@
          o_weakinv, o_dthmin, o_cldtau, &
          o_cldemi, o_pr_con_l, o_pr_con_i, &
-         o_pr_lsc_l, o_pr_lsc_i, o_re, o_fl, &
+         o_pr_lsc_l, o_pr_lsc_i, o_pr_bs, o_re, o_fl, &
          o_rh2m, &
          o_qsat2m, o_tpot, o_tpote, o_SWnetOR, &
@@ -134,14 +136,15 @@
          o_cldicemxrat, o_cldwatmxrat, o_reffclwtop, o_ec550aer, &
          o_lwcon, o_iwcon, o_temp, o_theta, &
-         o_ovapinit, o_ovap, o_oliq, o_ocond, o_geop, &
+         o_ovapinit, o_ovap, o_oliq, o_ocond, o_geop,o_qbs, &
          o_vitu, o_vitv, o_vitw, o_pres, o_paprs, &
          o_zfull, o_zhalf, o_rneb, o_rnebjn, o_rnebcon, &
          o_rnebls, o_rneblsvol, o_rhum, o_rhl, o_rhi, o_ozone, o_ozone_light, &
+         o_pfraclr, o_pfracld, &
          o_duphy, o_dtphy, o_dqphy, o_dqphy2d, o_dqlphy, o_dqlphy2d, &
-         o_dqsphy, o_dqsphy2d, o_albe_srf, o_z0m_srf, o_z0h_srf, &
+         o_dqsphy, o_dqsphy2d, o_dqbsphy, o_dqbsphy2d, o_albe_srf, o_z0m_srf, o_z0h_srf, &
          o_ages_srf, o_snow_srf, o_alb1, o_alb2, o_tke, o_tke_dissip, &
          o_tke_max, o_kz, o_kz_max, o_clwcon, &
          o_dtdyn, o_dqdyn, o_dqdyn2d, o_dqldyn, o_dqldyn2d, & 
-         o_dqsdyn, o_dqsdyn2d, o_dudyn, o_dvdyn, &
+         o_dqsdyn, o_dqsdyn2d, o_dqbsdyn, o_dqbsdyn2d, o_dudyn, o_dvdyn, &
          o_dtcon, o_tntc, o_ducon, o_dvcon, &
          o_dqcon, o_dqcon2d, o_tnhusc, o_tnhusc, o_dtlsc, &
@@ -151,4 +154,5 @@
          o_ptconvth, o_lmaxth, o_dtvdf, &
          o_dtdis, o_dqvdf, o_dqvdf2d, o_dteva, o_dqeva, o_dqeva2d, &
+         o_dqbsvdf, o_dtbs, o_dqbs, o_dqbsbs, &
          o_ptconv, o_ratqs, o_dtthe, & 
          o_duthe, o_dvthe, o_ftime_th, &
@@ -204,4 +208,5 @@
          o_dxtajs,o_dxtvdf,o_dxtthe, o_dxtch4, &
          o_dxtprod_nucl,o_dxtcosmo,o_dxtdecroiss, &
+         o_xtevap_srf, &
 #endif
 ! Tropopause
@@ -219,5 +224,13 @@
          o_flx_co2_ff, o_flx_co2_bb, & 
          o_delta_sst, o_delta_sal, o_ds_ns, o_dt_ns, o_dter, o_dser, o_tkt, &
-         o_tks, o_taur, o_sss
+         o_tks, o_taur, o_sss, &
+!FC
+         o_zxfluxt,o_zxfluxq
+
+#ifdef CPP_ECRAD
+    USE phys_output_ctrlout_mod, ONLY:  &
+         o_soll0_s2,o_soll_s2,o_sols0_s2,o_sols_s2, &
+         o_topl0_s2,o_topl_s2,o_tops0_s2,o_tops_s2   
+#endif
 
 #ifdef CPP_StratAer
@@ -236,10 +249,4 @@
 #endif
 
-#ifdef CPP_ECRAD
-    USE phys_output_ctrlout_mod, ONLY:  &
-         o_soll0_s2,o_soll_s2,o_sols0_s2,o_sols_s2, &
-         o_topl0_s2,o_topl_s2,o_tops0_s2,o_tops_s2
-#endif
-
     USE ice_sursat_mod, ONLY: flight_m, flight_h2o
     
@@ -247,7 +254,7 @@
     USE phys_state_var_mod, ONLY: heat_volc, cool_volc !NL
 
-    USE phys_state_var_mod, ONLY: pctsrf, rain_fall, snow_fall, &
+    USE phys_state_var_mod, ONLY: pctsrf, rain_fall, snow_fall, bs_fall,&
          qsol, z0m, z0h, fevap, agesno, &
-         nday_rain, rain_con, snow_con, &
+         nday_rain, ndayrain_mth, rain_con, snow_con, &
          topsw, toplw, toplw0, swup, swdn, solswfdiff, &
          topsw0, swupc0, swdnc0, swup0, swdn0, SWup200, SWup200clr, &
@@ -275,8 +282,8 @@
          wTSTD, u2STD, v2STD, T2STD, missing_val_nf90, delta_sal, ds_ns, &
 #ifdef ISO
-        xtrain_con, xtsnow_con, xtrain_fall, xtsnow_fall, &
+        xtrain_con, xtsnow_con, xtrain_fall, xtsnow_fall, fxtevap, &
 #endif
          dt_ns, delta_sst, dter, dser
-
+         
 ! AI 08 2023 pour ECRAD 3Deffect
 #ifdef CPP_ECRAD
@@ -286,6 +293,8 @@
 #endif
 
+
     USE phys_local_var_mod, ONLY: zxfluxlat, slp, ptstar, pt0, zxtsol, zt2m, &
          zn2mout, t2m_min_mon, t2m_max_mon, evap, &
+         snowerosion, zxustartlic, zxrhoslic, &
          l_mixmin,l_mix, tke_dissip, &
          zu10m, zv10m, zq2m, zustar, zxqsurf, &
@@ -301,5 +310,5 @@
          uwat, vwat, &
          rneb_seri, d_rneb_dyn, &
-         plcl, plfc, wbeff, convoccur, upwd, dnwd, dnwd0, prw, prlw, prsw, &
+         plcl, plfc, wbeff, convoccur, upwd, dnwd, dnwd0, prw, prlw, prsw,prbsw, &
          s_pblh, s_pblt, s_lcl, s_therm, uwriteSTD, &
          vwriteSTD, wwriteSTD, phiwriteSTD, qwriteSTD, &
@@ -321,5 +330,5 @@
          alp_bl_stat, alp_bl_fluct_tke, slab_wfbils, &
          weak_inversion, dthmin, cldtau, cldemi, &
-         pmflxr, pmflxs, prfl, psfl, re, fl, rh2m, &
+         pmflxr, pmflxs, prfl, psfl,bsfl, re, fl, rh2m, &
          qsat2m, tpote, tpot, d_ts, od443aer, od550aer, dryod550aer, &
          od865aer, abs550aer, od550lt1aer, sconcso4, sconcno3, &
@@ -333,13 +342,13 @@
          toplwad_aero, toplwad0_aero, sollwad_aero, &
          sollwad0_aero, toplwai_aero, sollwai_aero, &
-         scdnc, cldncl, reffclws, reffclwc, cldnvi, stratomask,&
-         lcc, lcc3d, lcc3dcon, lcc3dstra, &
-         icc3dcon, icc3dstra, zfice, reffclwtop, &
+         stratomask,&
+         zfice, &
          ec550aer, flwc, fiwc, t_seri, theta, q_seri, &
-         ql_seri, qs_seri, tr_seri, &
+         ql_seri, qs_seri, qbs_seri, tr_seri, qbs_seri,&
          zphi, u_seri, v_seri, omega, cldfra, &
-         rneb, rnebjn, rneblsvol, zx_rh, zx_rhl, zx_rhi, d_t_dyn,  & 
-         d_q_dyn,  d_ql_dyn, d_qs_dyn, &
-         d_q_dyn2d,  d_ql_dyn2d, d_qs_dyn2d, &
+         rneb, rnebjn, rneblsvol, zx_rh, zx_rhl, zx_rhi, &
+         pfraclr, pfracld, d_t_dyn,  & 
+         d_q_dyn,  d_ql_dyn, d_qs_dyn, d_qbs_dyn,  &
+         d_q_dyn2d,  d_ql_dyn2d, d_qs_dyn2d, d_qbs_dyn2d, &
          d_u_dyn, d_v_dyn, d_t_con, d_t_ajsb, d_t_ajs, &
          d_u_ajs, d_v_ajs, &
@@ -349,4 +358,5 @@
          d_t_lscst, d_q_lscth, d_q_lscst, plul_th, &
          plul_st, d_t_vdf, d_t_diss, d_q_vdf, d_q_eva, &
+         d_t_bs, d_q_bs, d_qbs_bs, d_qbs_vdf, &
          zw2, fraca, zmax_th, d_q_ajsb, d_t_ec, d_u_vdf, &
          d_v_vdf, d_u_oro, d_v_oro, d_t_oro, d_u_lif, &
@@ -363,5 +373,11 @@
 #endif
          ep, epmax_diag, &  ! epmax_cape
-         p_tropopause, t_tropopause, z_tropopause
+         p_tropopause, t_tropopause, z_tropopause, &
+         zxfluxt,zxfluxq, &
+! offline 
+         da, mp, phi, wght_cvfd
+    USE phys_output_var_mod, ONLY: scdnc, cldncl, reffclwtop, lcc, reffclws, &
+         reffclwc, cldnvi, lcc3d, lcc3dcon, lcc3dstra, icc3dcon, icc3dstra
+    
 
 #ifdef CPP_StratAer 
@@ -419,11 +435,7 @@
     USE netcdf, ONLY: nf90_fill_real
     USE print_control_mod, ONLY: prt_level,lunout
-
-
-#ifdef CPP_XIOS
     ! ug Pour les sorties XIOS
-    USE xios
-    USE wxios, ONLY: wxios_closedef, missing_val, wxios_set_context
-#endif
+    USE lmdz_xios
+    USE wxios, ONLY: wxios_closedef, missing_val_xios=>missing_val, wxios_set_context
     USE phys_cal_mod, ONLY : mth_len
 
@@ -444,5 +456,5 @@
 
     ! Input
-    INTEGER :: itap, ivap, iliq, isol, read_climoz
+    INTEGER :: itap, ivap, iliq, isol, ibs, read_climoz
     INTEGER, DIMENSION(klon) :: lmax_th
     LOGICAL :: aerosol_couple, ok_sync
@@ -460,4 +472,7 @@
     INTEGER :: flag_aerosol 
     LOGICAL :: ok_cdnc
+    REAL, DIMENSION(klon,klev) :: t   ! output for phystoken - offline flux 
+    REAL, DIMENSION(klon) :: u1, v1   ! output for phystoken - offline flux
+    
     REAL, DIMENSION(3) :: freq_moyNMC
 
@@ -480,16 +495,13 @@
 !$OMP THREADPRIVATE(kmax_100m)
     REAL :: x
-#ifndef CPP_XIOS
     REAL :: missing_val
-#endif
     REAL, PARAMETER :: un_jour=86400.
+    CHARACTER(len=12) :: nvar    
     INTEGER :: ISW, itr, ixt, it
     CHARACTER*1 ch1
     CHARACTER(LEN=maxlen) :: varname, dn
-
-#ifdef CPP_XIOS
-    TYPE(xios_fieldgroup) :: group_handle
-    TYPE(xios_field) :: child
-#endif
+    REAL, DIMENSION(klon,klev) :: coefh_stok 
+    
+    
 #ifdef CPP_StratAer 
     LOGICAL, PARAMETER :: debug_strataer=.FALSE.
@@ -510,11 +522,11 @@
  !   ENDIF
 
-#ifdef CPP_XIOS
-    CALL wxios_set_context
-#endif
-
-#ifndef CPP_XIOS
-    missing_val=missing_val_nf90
-#endif
+    IF (using_xios) CALL wxios_set_context
+
+    IF (using_xios) THEN
+      missing_val=missing_val_xios
+    ELSE
+      missing_val=missing_val_nf90
+    ENDIF
 
     IF (.NOT.vars_defined) THEN
@@ -547,99 +559,21 @@
     END DO
 
-#ifdef CPP_XIOS
-#ifdef CPP_StratAer
-!$OMP MASTER
-   IF (.NOT.vars_defined) THEN
-          !On ajoute les variables 3D traceurs par l interface fortran 
-          CALL xios_get_handle("fields_strataer_trac_3D", group_handle)
-          ! On boucle sur les traceurs pour les ajouter au groupe puis fixer les attributs
-          DO iq = 1, nqtot
-            IF(.NOT.(tracers(iq)%isAdvected .AND. tracers(iq)%isInPhysics)) CYCLE
-            dn = 'd'//TRIM(tracers(iq)%name)//'_'
-            WRITE (lunout,*) 'XIOS var=', nqo, iq, nqtot, tracers(iq)%name
-
-            unt = "kg kg-1"
-            varname=trim(tracers(iq)%name)
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-
-            unt = "kg kg-1 s-1"
-            varname=TRIM(dn)//'vdf'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-            varname=TRIM(dn)//'the'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-            varname=TRIM(dn)//'con'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-            varname=TRIM(dn)//'lessi_impa'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-            varname=TRIM(dn)//'lessi_nucl'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-            varname=TRIM(dn)//'insc'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-            varname=TRIM(dn)//'bcscav'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-            varname=TRIM(dn)//'evapls'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-            varname=TRIM(dn)//'ls'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-            varname=TRIM(dn)//'trsp'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-            varname=TRIM(dn)//'sscav'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-            varname=TRIM(dn)//'sat'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-            varname=TRIM(dn)//'uscav'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-          END DO
-          !On ajoute les variables 2D traceurs par l interface fortran 
-          CALL xios_get_handle("fields_strataer_trac_2D", group_handle)
-          ! On boucle sur les traceurs pour les ajouter au groupe puis fixer les attributs
-          DO iq = 1, nqtot
-            IF(.NOT.(tracers(iq)%isAdvected .AND. tracers(iq)%isInPhysics)) CYCLE
-
-            unt = "kg m-2"
-            varname='cum'//trim(tracers(iq)%name)
-            WRITE (lunout,*) 'XIOS var=', iq, nqtot, varname
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-
-            unt = "kg m-2 s-1"
-            varname='cumd'//trim(tracers(iq)%name)//'_dry'
-            CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit=unt)
-          ENDDO
-    ENDIF
-!$OMP END MASTER
-#endif
-#endif
 
     ! ug la boucle qui suit ne sert qu'une fois, pour l'initialisation, sinon il n'y a toujours qu'un seul passage:
     DO iinit=1, iinitend
 !      print *,'IFF iinit=', iinit, iinitend 
-#ifdef CPP_XIOS
-       !$OMP MASTER
-       IF (vars_defined) THEN
-          IF (prt_level >= 10) then
-             write(lunout,*)"phys_output_write: call xios_update_calendar, itau_w=",itau_w
-          ENDIF
-!          CALL xios_update_calendar(itau_w)
-          CALL xios_update_calendar(itap)
-       ENDIF
-       !$OMP END MASTER
-       !$OMP BARRIER
-#endif
+       IF (using_xios) THEN
+         !$OMP MASTER
+         IF (vars_defined) THEN
+            IF (prt_level >= 10) then
+               write(lunout,*)"phys_output_write: call xios_update_calendar, itau_w=",itau_w
+            ENDIF
+!            CALL xios_update_calendar(itau_w)
+            CALL xios_update_calendar(itap)
+         ENDIF
+         !$OMP END MASTER
+         !$OMP BARRIER
+       ENDIF
+
        ! On procède à l'écriture ou à la définition des nombreuses variables:
 !!! Champs 1D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -664,38 +598,39 @@
        CALL histwrite_phy(o_contfracOR, pctsrf(:,is_ter))
 !
-#ifdef CPP_XIOS
-       CALL histwrite_phy("R_ecc",R_ecc)
-       CALL histwrite_phy("R_peri",R_peri)
-       CALL histwrite_phy("R_incl",R_incl)
-       CALL histwrite_phy("solaire",solaire)
-       CALL histwrite_phy(o_Ahyb, ap)
-       CALL histwrite_phy(o_Bhyb, bp)
-       CALL histwrite_phy(o_Ahyb_bounds, Ahyb_bounds)
-       CALL histwrite_phy(o_Bhyb_bounds, Bhyb_bounds)
-       CALL histwrite_phy(o_Ahyb_mid, aps)
-       CALL histwrite_phy(o_Bhyb_mid, bps)
-       CALL histwrite_phy(o_Ahyb_mid_bounds, Ahyb_mid_bounds)
-       CALL histwrite_phy(o_Bhyb_mid_bounds, Bhyb_mid_bounds)
-       CALL histwrite_phy(o_longitude, longitude_deg)
-       CALL histwrite_phy(o_latitude, latitude_deg)
+       IF (using_xios) THEN
+
+         CALL histwrite_phy("R_ecc",R_ecc)
+         CALL histwrite_phy("R_peri",R_peri)
+         CALL histwrite_phy("R_incl",R_incl)
+         CALL histwrite_phy("solaire",solaire)
+         CALL histwrite_phy(o_Ahyb, ap)
+         CALL histwrite_phy(o_Bhyb, bp)
+         CALL histwrite_phy(o_Ahyb_bounds, Ahyb_bounds)
+         CALL histwrite_phy(o_Bhyb_bounds, Bhyb_bounds)
+         CALL histwrite_phy(o_Ahyb_mid, aps)
+         CALL histwrite_phy(o_Bhyb_mid, bps)
+         CALL histwrite_phy(o_Ahyb_mid_bounds, Ahyb_mid_bounds)
+         CALL histwrite_phy(o_Bhyb_mid_bounds, Bhyb_mid_bounds)
+         CALL histwrite_phy(o_longitude, longitude_deg)
+         CALL histwrite_phy(o_latitude, latitude_deg)
 !
 #ifdef CPP_RRTM
-      IF (iflag_rrtm.EQ.1) THEN
-        DO ISW=1, NSW
-          WRITE(ch1,'(i1)') ISW
-!         zx_tmp_0d=RSUN(ISW)
-!         CALL histwrite_phy("rsun"//ch1,zx_tmp_0d)
-          CALL histwrite_phy("rsun"//ch1,RSUN(ISW))
-        ENDDO
-      ENDIF
+        IF (iflag_rrtm.EQ.1) THEN
+          DO ISW=1, NSW
+            WRITE(ch1,'(i1)') ISW
+  !         zx_tmp_0d=RSUN(ISW)
+  !         CALL histwrite_phy("rsun"//ch1,zx_tmp_0d)
+            CALL histwrite_phy("rsun"//ch1,RSUN(ISW))
+          ENDDO
+        ENDIF
 #endif
 !
-       CALL histwrite_phy("co2_ppm",co2_ppm)
-       CALL histwrite_phy("CH4_ppb",CH4_ppb)
-       CALL histwrite_phy("N2O_ppb",N2O_ppb)
-       CALL histwrite_phy("CFC11_ppt",CFC11_ppt)
-       CALL histwrite_phy("CFC12_ppt",CFC12_ppt)
+        CALL histwrite_phy("co2_ppm",co2_ppm)
+        CALL histwrite_phy("CH4_ppb",CH4_ppb)
+        CALL histwrite_phy("N2O_ppb",N2O_ppb)
+        CALL histwrite_phy("CFC11_ppt",CFC11_ppt)
+        CALL histwrite_phy("CFC12_ppt",CFC12_ppt)
 !
-#endif
+      ENDIF !using_xios
 
 !!! Champs 2D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -900,12 +835,18 @@
 
        IF (vars_defined) THEN
-          DO i = 1, klon
+          IF (ok_bs) THEN
+             DO i = 1, klon
+             zx_tmp_fi2d(i) = rain_fall(i) + snow_fall(i) + bs_fall(i)
+             ENDDO
+          ELSE
+             DO i = 1, klon
              zx_tmp_fi2d(i) = rain_fall(i) + snow_fall(i)
-          ENDDO
+             ENDDO
+          ENDIF
        ENDIF
 
        CALL histwrite_phy(o_precip, zx_tmp_fi2d)
        CALL histwrite_phy(o_rain_fall, rain_fall)
-       CALL histwrite_phy(o_ndayrain, nday_rain)
+       CALL histwrite_phy(o_ndayrain, ndayrain_mth)
 
        ! epmax_cape:
@@ -933,4 +874,11 @@
        CALL histwrite_phy(o_evap, evap)
 
+       IF (ok_bs) THEN
+           CALL histwrite_phy(o_bsfall, bs_fall)     
+           CALL histwrite_phy(o_snowerosion, snowerosion)
+           CALL histwrite_phy(o_ustart_lic, zxustartlic)
+           CALL histwrite_phy(o_rhosnow_lic, zxrhoslic)
+       ENDIF
+
        IF (vars_defined) THEN
          zx_tmp_fi2d = topsw*swradcorr
@@ -946,4 +894,41 @@
        CALL histwrite_phy(o_topl0, toplw0)
 
+! offline 
+       IF (using_xios) THEN
+         IF (offline) THEN
+
+            coefh_stok(:,1)      = cdragh(:)
+            coefh_stok(:,2:klev) = coefh(:,2:klev, is_ave)
+          
+            CALL histwrite_phy('upwd_stok', upwd)
+            CALL histwrite_phy('t_stok', t)
+            CALL histwrite_phy('fm_th_stok', fm_therm(:,1:klev))
+            CALL histwrite_phy('en_th_stok', entr_therm)
+            CALL histwrite_phy('da_stok',da )
+            CALL histwrite_phy('mp_stok',mp )
+            CALL histwrite_phy('dnwd_stok', dnwd)
+            CALL histwrite_phy('wght_stok', wght_cvfd)
+            CALL histwrite_phy('coefh_stok', coefh_stok)
+            CALL histwrite_phy('yu1_stok', u1) 
+            CALL histwrite_phy('yv1_stok', v1)
+
+            DO k=1,klev
+               IF (k<10) THEN
+                  WRITE(nvar,'(i1)') k
+               ELSE IF (k<100) THEN
+                  WRITE(nvar,'(i2)') k
+               ELSE
+                  WRITE(nvar,'(i3)') k
+               END IF
+               nvar='phi_lev'//trim(nvar)
+               CALL histwrite_phy(nvar,phi(:,:,k))
+            END DO
+          
+         ENDIF
+       ENDIF
+
+
+
+       
        IF (vars_defined) THEN
           zx_tmp_fi2d(:) = swup(:,klevp1)*swradcorr(:)
@@ -1146,15 +1131,4 @@
        ENDIF
        CALL histwrite_phy(o_tauy, zx_tmp_fi2d)
-
-       ! Etienne: test sorties pour compil sur JZ
-!       IF (landice_opt .GE. 1) THEN
-!          CALL histwrite_phy(o_snowsrf, snow_o)
-!          CALL histwrite_phy(o_qsnow, qsnow)
-!          CALL histwrite_phy(o_snowhgt,snowhgt)
-!          CALL histwrite_phy(o_toice,to_ice)
-!          CALL histwrite_phy(o_sissnow,sissnow)
-!          CALL histwrite_phy(o_runoff,runoff)
-!          CALL histwrite_phy(o_albslw3,albsol3_lic)
-!       ENDIF
 
        DO nsrf = 1, nbsrf
@@ -1322,4 +1296,7 @@
        CALL histwrite_phy(o_prlw, prlw)
        CALL histwrite_phy(o_prsw, prsw)
+       IF (ok_bs) THEN
+       CALL histwrite_phy(o_prbsw, prbsw)
+       ENDIF
        CALL histwrite_phy(o_s_pblh, s_pblh)
        CALL histwrite_phy(o_s_pblt, s_pblt)
@@ -1353,54 +1330,56 @@
 
 #ifdef CPP_IOIPSL
-#ifndef CPP_XIOS
-  IF (.NOT.ok_all_xml) THEN
-       ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
-       ! Champs interpolles sur des niveaux de pression
-       DO iff=1, nfiles
-          ll=0
-          DO k=1, nlevSTD
-             bb2=clevSTD(k) 
-             IF (bb2.EQ."850".OR.bb2.EQ."700".OR. &
+       IF (.NOT. using_xios) THEN
+         IF (.NOT.ok_all_xml) THEN
+           ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
+           ! Champs interpolles sur des niveaux de pression
+            DO iff=1, nfiles
+              ll=0
+              DO k=1, nlevSTD
+                bb2=clevSTD(k) 
+                  IF (bb2.EQ."850".OR.bb2.EQ."700".OR. &
+                       bb2.EQ."500".OR.bb2.EQ."200".OR. &
+                       bb2.EQ."100".OR. &
+                       bb2.EQ."50".OR.bb2.EQ."10") THEN
+
+                      ! a refaire correctement !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+                      ll=ll+1
+                      CALL histwrite_phy(o_uSTDlevs(ll),uwriteSTD(:,k,iff), iff)
+                      CALL histwrite_phy(o_vSTDlevs(ll),vwriteSTD(:,k,iff), iff)
+                      CALL histwrite_phy(o_wSTDlevs(ll),wwriteSTD(:,k,iff), iff)
+                      CALL histwrite_phy(o_zSTDlevs(ll),phiwriteSTD(:,k,iff), iff)
+                      CALL histwrite_phy(o_qSTDlevs(ll),qwriteSTD(:,k,iff), iff)
+                      CALL histwrite_phy(o_tSTDlevs(ll),twriteSTD(:,k,iff), iff)
+
+                  ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR.
+              ENDDO
+            ENDDO
+         ENDIF
+       ENDIF
+#endif
+
+       IF (using_xios) THEN
+         IF (ok_all_xml) THEN
+           !XIOS  CALL xios_get_field_attr("u850",default_value=missing_val)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+            ll=0
+            DO k=1, nlevSTD
+              bb2=clevSTD(k) 
+              IF (bb2.EQ."850".OR.bb2.EQ."700".OR. &
                   bb2.EQ."500".OR.bb2.EQ."200".OR. &
                   bb2.EQ."100".OR. &
                   bb2.EQ."50".OR.bb2.EQ."10") THEN
-
-                ! a refaire correctement !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-                ll=ll+1
-                CALL histwrite_phy(o_uSTDlevs(ll),uwriteSTD(:,k,iff), iff)
-                CALL histwrite_phy(o_vSTDlevs(ll),vwriteSTD(:,k,iff), iff)
-                CALL histwrite_phy(o_wSTDlevs(ll),wwriteSTD(:,k,iff), iff)
-                CALL histwrite_phy(o_zSTDlevs(ll),phiwriteSTD(:,k,iff), iff)
-                CALL histwrite_phy(o_qSTDlevs(ll),qwriteSTD(:,k,iff), iff)
-                CALL histwrite_phy(o_tSTDlevs(ll),twriteSTD(:,k,iff), iff)
-
-             ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR.
-          ENDDO
-       ENDDO
-  ENDIF
-#endif
-#endif
-#ifdef CPP_XIOS
-  IF (ok_all_xml) THEN
-!XIOS  CALL xios_get_field_attr("u850",default_value=missing_val)
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-          ll=0
-          DO k=1, nlevSTD
-             bb2=clevSTD(k) 
-             IF (bb2.EQ."850".OR.bb2.EQ."700".OR. &
-                bb2.EQ."500".OR.bb2.EQ."200".OR. &
-                bb2.EQ."100".OR. &
-                bb2.EQ."50".OR.bb2.EQ."10") THEN
-                ll=ll+1
-                CALL histwrite_phy(o_uSTDlevs(ll),ulevSTD(:,k))
-                CALL histwrite_phy(o_vSTDlevs(ll),vlevSTD(:,k))
-                CALL histwrite_phy(o_wSTDlevs(ll),wlevSTD(:,k))
-                CALL histwrite_phy(o_zSTDlevs(ll),philevSTD(:,k))
-                CALL histwrite_phy(o_qSTDlevs(ll),qlevSTD(:,k))
-                CALL histwrite_phy(o_tSTDlevs(ll),tlevSTD(:,k))
-             ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR.
-          ENDDO
-  ENDIF
-#endif
+                  ll=ll+1
+                  CALL histwrite_phy(o_uSTDlevs(ll),ulevSTD(:,k))
+                  CALL histwrite_phy(o_vSTDlevs(ll),vlevSTD(:,k))
+                  CALL histwrite_phy(o_wSTDlevs(ll),wlevSTD(:,k))
+                  CALL histwrite_phy(o_zSTDlevs(ll),philevSTD(:,k))
+                  CALL histwrite_phy(o_qSTDlevs(ll),qlevSTD(:,k))
+                  CALL histwrite_phy(o_tSTDlevs(ll),tlevSTD(:,k))
+              ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR.
+            ENDDO
+         ENDIF
+       ENDIF
+
        IF (vars_defined) THEN
           DO i=1, klon
@@ -1567,4 +1546,9 @@
        CALL histwrite_phy(o_re, re)
        CALL histwrite_phy(o_fl, fl)
+
+       IF (ok_bs) THEN
+         CALL histwrite_phy(o_pr_bs, bsfl(:,1:klev))
+       ENDIF
+
        IF (vars_defined) THEN
           DO i=1, klon
@@ -1824,4 +1808,8 @@
        CALL histwrite_phy(o_ovap, q_seri)
        CALL histwrite_phy(o_oliq, ql_seri)
+       !FC
+       CALL histwrite_phy(o_zxfluxt, zxfluxt)
+       CALL histwrite_phy(o_zxfluxq, zx_tmp_fi3d)
+       !FC
 
        IF (vars_defined) zx_tmp_fi3d = ql_seri+qs_seri
@@ -1838,18 +1826,22 @@
        CALL histwrite_phy(o_zfull,zx_tmp_fi3d)
 
-#ifdef CPP_XIOS
+       IF (ok_bs) THEN
+          CALL histwrite_phy(o_qbs, qbs_seri)
+       ENDIF
+
+       IF (using_xios) THEN
 !solbnd begin
 #ifdef CPP_RRTM
-      IF (iflag_rrtm.EQ.1) THEN
-       IF (vars_defined) THEN
-        DO ISW=1, NSW
-          zx_tmp_fi3dsp(:,ISW) = swdn(:,klevp1)*swradcorr(:)*RSUN(ISW)
-        ENDDO
-        CALL histwrite_phy(o_solbnd, zx_tmp_fi3dsp)
-       ENDIF
-      ENDIF
+         IF (iflag_rrtm.EQ.1) THEN
+           IF (vars_defined) THEN
+             DO ISW=1, NSW
+               zx_tmp_fi3dsp(:,ISW) = swdn(:,klevp1)*swradcorr(:)*RSUN(ISW)
+             ENDDO
+             CALL histwrite_phy(o_solbnd, zx_tmp_fi3dsp)
+           ENDIF
+         ENDIF
 #endif
 !solbnd end
-#endif
+       ENDIF
 #endif
 
@@ -1887,4 +1879,9 @@
           IF (vars_defined) zx_tmp_fi3d = zx_rhi * 100.
           CALL histwrite_phy(o_rhi, zx_tmp_fi3d)
+       ENDIF
+     
+       IF (ok_new_lscp) THEN
+           CALL histwrite_phy(o_pfraclr, pfraclr)
+           CALL histwrite_phy(o_pfracld, pfracld)
        ENDIF
 
@@ -1949,4 +1946,16 @@
        zx_tmp_fi2d=0.0
        CALL histwrite_phy(o_dqsphy2d,  zx_tmp_fi2d)
+       ENDIF
+
+
+       IF (ok_bs) THEN
+       CALL histwrite_phy(o_dqbsphy,  d_qx(:,:,ibs))
+       IF (vars_defined) CALL water_int(klon,klev,d_qx(:,:,ibs),zmasse,zx_tmp_fi2d)
+       CALL histwrite_phy(o_dqbsphy2d,  zx_tmp_fi2d)
+       ELSE
+       zx_tmp_fi3d=0.0
+       CALL histwrite_phy(o_dqbsphy,  zx_tmp_fi3d)
+       zx_tmp_fi2d=0.0
+       CALL histwrite_phy(o_dqbsphy2d,  zx_tmp_fi2d)
        ENDIF
 
@@ -1999,4 +2008,9 @@
 
        CALL histwrite_phy(o_dqsdyn2d, d_qs_dyn2d)
+
+       IF (ok_bs) THEN
+       CALL histwrite_phy(o_dqbsdyn, d_qbs_dyn)
+       CALL histwrite_phy(o_dqbsdyn2d, d_qbs_dyn2d)
+       ENDIF
 
        CALL histwrite_phy(o_dudyn, d_u_dyn)
@@ -2143,4 +2157,15 @@
        CALL histwrite_phy(o_dvthe, zx_tmp_fi3d)
 
+       IF (ok_bs) THEN
+          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_qbs_vdf(1:klon,1:klev)/pdtphys
+          CALL histwrite_phy(o_dqbsvdf, zx_tmp_fi3d)
+          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_qbs_bs(1:klon,1:klev)/pdtphys
+          CALL histwrite_phy(o_dqbsbs, zx_tmp_fi3d)
+          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_q_bs(1:klon,1:klev)/pdtphys
+          CALL histwrite_phy(o_dqbs, zx_tmp_fi3d)
+          IF (vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_t_bs(1:klon,1:klev)/pdtphys
+          CALL histwrite_phy(o_dtbs, zx_tmp_fi3d)
+       ENDIF
+
        IF (iflag_thermals>=1) THEN
           ! Pour l instant 0 a y reflichir pour les thermiques
